// My first C-programm

#include <stdio.h>		// I/O with C
#include <iostream>	// standard I/O with C++
#include <fstream>	// file I/O with C++
#include <stdlib.h>
using namespace std;

int main(int argc, char* argv[])
{
	// Dynamic allocation of an array 
	int numEntries, i;
	printf("\nCreate an array. Please input array size: ");
	scanf("%d",&numEntries);		// standard input
	int *f=(int*) malloc(numEntries*sizeof(int));	// allocate numEntries integers
	for(i=0;i<numEntries;i++) f[i]=i;

	// Write array to a file
	char *fileName="IOExample.txt";
	printf("\nOutput array length and elements into the file \"%s\"\n",fileName);
	FILE *ostream=fopen(fileName,"w");
	if (ostream==NULL) fprintf(stderr,"Error opening the file %s",fileName);
	else 
	{
		fprintf(ostream,"%d ",numEntries);	
		for(i=0;i<numEntries;i++) fprintf(ostream,"%d ",f[i]);	
	}
	fclose(ostream);
	free(f);

	// Read array to a file
	printf("\nInput array length and elements from the file \"%s\"\n",fileName);
	FILE *istream=fopen(fileName,"r");
	if (ostream==NULL) fprintf(stderr,"Error opening the file %s",fileName);
	else 
	{
		fscanf(istream,"%d",&numEntries);	
		f=(int*) malloc(numEntries*sizeof(int));	// allocate numEntries integers
		for(i=0;i<numEntries;i++) fscanf(istream,"%d",&f[i]);	
	}
	fclose(istream);

	// Output the array read 
	printf("\nThe array read from the file has the following %d entries:\n",numEntries);
	for(i=0;i<numEntries;i++) printf("%d ",f[i]);	


	// the same with C++
	cout << "\n\nAnd now some input and output with C++";
	int a=5;
	cout << "\nSome standard input and output";
	cout << "\nThe value of a is: " << a;
	cout << "\nInput a new value for a: ";
	cin >> a;
	cout << "\nThe new value of a is: " << a;

	cout << "\n\nSome file output";
	ofstream outFile("fstreamDemo.txt", ios::out);
	outFile << a;
	cout << "\nwrote the value a=" << a;
	outFile.close();

	a=10;		// change it in order to see whether the value from the file is read
	cout << "\n\nSome file input";
	ifstream inFile("fstreamDemo.txt", ios::in);
	inFile >> a;
	cout << "\nread the value a=" << a << "\n";
	inFile.close();

	return 0;
}

	